pub type Result<T> = std::result::Result<T, Error>;

#[derive(Debug)]
pub enum Error {
	Other(String),

	Reqwest(reqwest::Error),
}

impl std::error::Error for Error {}

impl std::fmt::Display for Error {
	fn fmt(&self, fmt: &mut std::fmt::Formatter) -> std::result::Result<(), std::fmt::Error> {
		write!(fmt, "{self:?}")
	}
}

impl From<&str> for Error {
	fn from(val: &str) -> Self {
		Self::Other(val.to_string())
	}
}

impl From<reqwest::Error> for Error {
	fn from(err: reqwest::Error) -> Self {
		Self::Reqwest(err)
	}
}
